1.2 Explorant la interfície

# La interfície de Sonic Pi

Sonic Pi té una interfície molt senzilla per programar música. Donem-li una ullada.

![Interfície de Sonic Pi](../../../etc/doc/images/tutorial/GUI.png)


*A* - Controls d'execució
*B* - Controls d'edició
*C* - Informació i ajuda
*D* - Editor de codi
*E* - Tauler de preferències
*F* - Visor de registre
*G* - Sistema d'ajuda
*H* - Visor
*I* - Cue Viewer

## A. Controls d'execució

Aquests botons rosa són els controls principals per començar i aturar sons. Hi ha el botó *Run*, que serveix per iniciar l'execució del codi; el botó *Stop*, per aturar tot el codi en execució; *Save*, per desar el codi a un arxiu extern; i *Record*, per crear un enregistrament (un arxiu WAV) dels sons executats.

## B. Controls d'edició

Aquests botons taronja permeté manipular l'editor de codi. Els botons *Size +* i *Size -* permeten fer el text més gran i més menut.

## C. Informació i Ajuda

Aquests botons blaus et donen accès a informació, ajuda i preferències. El botó *Info* obre la finestra d'informació, la qual conté informació sobre el propi programa Sonic Pi -l'equip base, la seua història, els contribuïdors i la comunitat. El botó *Help* mostra o amaga el sistema d'ajuda (*G*) i el botó *Prefs* activa la finestra de preferències, que et permet controlar alguns paràmetres bàsics del sistema.

## D. Editor de codi

Aquesta és l'àrea on escriuràs el teu codi i composaràs/interpretaràs música. És un editor de text senzill on pots escriure codi, esborrar-lo, copiar-lo i enganxar-lo, etc. Pensa que és una versió simplificada de Word o Google Docs. L'editor pintarà de diferents colors el codi automàticament, tenint en compte el significat del codi. Al principi, això pot semblar estrany, però prompte ho trobaràs molt útil. Per exemple, sabràs que quelcom és un número perquè és de color blau.

## E. Tauler de preferències

Sonic Pi permet canviar certs paràmetres accessibles a través del botó *Prefs*. Aquest botó mostra o amaga el tauler de preferències, el qual inclou diverses opcions que poden ser canviades. Per exemple, forçar el mode mono, invertir l'estèreo, mostrar o amagar l'eixida de registre, així com un controlador de volum i un selector d'àudio per a la Raspberry Pi.

## F. Visor de registre

Quan executeu codi, el visualitzador del registre mostra informació sobre allò que està fent el programa. Per defecte, veureu un missatge per cada so que creeu amb el temps exacte en què fou disparat aquest so. Açò és molt útil per depurar codi i entendre què és el que el vostre codi està fent.

## G. Sistema d'ajuda

Una de les parts més importants de la interfície de Sonic Pi és el sistema d'ajuda que apareix a la part inferior de la finestra. Pot ser activat/desactivat clickant a botó blau *Ajuda*. Aquest sistema d'ajuda conté informació sobre tots els aspectes de Sonic Pi incloent aquest tutorial, una llista dels sintetitzadors disponibles, samples, exemples, efectes (FX) i una llista complerta de tots els mètodes que Sonic Pi proveeix per crear música programàticament.

## H. Visor osciloscòpic

El visor osciloscòpic et permet veure el so que estàs escoltant. Podeu veure fàcilment que l'ona de serra sembla una serra i que el xiulet bàsic és una curva d'ona sinusoïdal. També podeu veure la diferència entre sons forts i fluixos per la mida de les línies. Hi ha 3 visors per jugar - el que apareix per defecte és un visor que combina els canals esquerre i dret, i hi ha un visor estèreo que dibuixa una ona separada per cada canal. Finalment hi ha un visor de corba Lissajous que mostrarà la relació de fase entre els canals esquerre i dret i us permetrà dibuixar imatges boniques amb so (https://ca.wikipedia.org/wiki/Corba_de_Lissajous).

## I. Cue Viewer

All internal and external events (called cues in Sonic Pi) are automatically logged in the Cue Viewer. For example, if you have a MIDI controller connected and press one of its buttons, you'll see a new cue event in the Cue Viewer telling you the name of the controller and which button you pressed. Once you've mastered the basics of making and producing sounds, you'll start to want to cue sounds or whole sections of sounds based on events such as these. A cue event is just an indication that something happened. For example, every time a live loop spins round, it sends a cue event out which is logged in the Cue Viewer. Also, external events such as MIDI messages from connected MIDI equipment and OSC messages from other programs or computers are also displayed in the Cue Viewer. It is also possible to directly generate cue events using the `cue` function. Anything that appears in the Cue Viewer can be used to trigger something happening. This is covered in more detail in Sections 10 to 12 of this tutorial.
