1.2 Explorando la interfaz

# La interfaz de Sonic Pi

Sonic Pi tiene una interfaz sencilla para programar música. Echemos un vistazo a esto.

![La Interfaz de Sonic Pi](../../../etc/doc/images/tutorial/GUI.png)


*A* - Controles de Ejecución
*B* - Controles de edición
*C* - Información y Ayuda
*D* - Editor de código
*E* - Panel de Preferencias
*F* - Visor de Registros
*G* - Sistema de Ayuda
*H* - Visor de Registros
*I* - Cue Viewer

## A. Controles de Ejecución

Estos botones rosados son los principales controles para comenzar y parar sonidos. El botón de *Ejecutar* sirve para iniciar la ejecución del código y *Parar* para parar todo código en Ejecución, *Guardar* para guardar el código a un archivo externo y *Grabar* para crear una grabación (archivo WAV) de los sonidos ejecutándose.

## B. Controles de edición

Estos botones naranjas te permiten manipular el editor de código. Los botones de *Tamaño +* y Tamaño -* te permiten aumentar y disminuir el tamaño del texto.

## C. Información y Ayuda

Estos botones azules te dan acceso a información, ayuda y preferencias. El botón *Info* abre la ventana informativa, la cual contiene información del propio programa Sonic Pi - el equipo base, historia, contribuyentes y la comunidad. El botón de *Ayuda* muestra u oculta el sistema de ayuda y el botón *Preferencias* activa la ventana de preferencias, que te permite controlar algunos parámetros básicos del sistema.

## D. Editor de código

Esta es el área donde escribirás tu código y compondrás/ejecutarás música. Es un sencillo editor de texto donde puedes escribir, borrar, cortar, pegar, etc. Piensa que es una versión simplificada de Word o Google Docs. El editor colorea las palabras automáticamente, basado en su significado para el código. Al principio, esto puede parecer extraño, pero pronto lo encontrarás muy útil. Por ejemplo, sabrás que algo es un número, porque es de color azul.

## E. Panel de Preferencias

Sonic Pi permite cambiar ciertos parámetros accesibles a través del botón *preferencias* . Este botón cambia la visibilidad del panel de preferencias, el cual incluye un número de opciones a ser cambiadas. Por ejemplo forzar el modo mono, invertir el estéreo, cambiar a vista/no vista de la bitácora, mando de volumen y un selector de audio para la Raspberry Pi.

## F. Visor de Log

Cuando ejecutas un código, el visualizador del log muestra información de lo que está haciendo el programa. Predeterminado está el que veas un mensaje por cada sonido que crees con el tiempo exacto al que fue disparado el sonido. Esto es muy útil para depurar código y entender qué es lo que está haciendo.

## G. Sistema de ayuda

Finalmente, una de las partes más importantes de la interfaz de Sonic Pi es el sistema de ayuda que aparece en la parte baja de la ventana. Esta puede ser activada o desactivada al apretar el botón azul «Ayuda». El sistema de ayuda contiene información de todos los aspectos de Sonic Pi incluído este tutorial, listado de sintetizadores disponibles, muestras (samples), ejemplos, efectos y una lista de todas las funciones que Sonic Pi provee para codificar música.

## H. Visor Osciloscópico

El visor de alcance le permite ver el sonido que esta escuchando. Usted puede ver fácilmente que la onda de la sierra parece una sierra y que el pitido básico es una curva de onda senoidal. También puede ver la diferencia entre sonidos fuertes y silenciosos por el tamaño de las líneas. Hay 3 alcances para jugar - el defecto es un alcance combinado para los canales izquierdos y derechos, hay un alcance estéreo que dibuja un alcance separado para cada canal. Finalmente hay un alcance de curva Lissajous que mostrará la relación de fase entre los canales izquierdo y derecho y le permitirá dibujar imágenes bonitas con sonido (https://en.wikipedia.org/wiki/Lissajous_curve).

## I. Cue Viewer

All internal and external events (called cues in Sonic Pi) are automatically logged in the Cue Viewer. For example, if you have a MIDI controller connected and press one of its buttons, you'll see a new cue event in the Cue Viewer telling you the name of the controller and which button you pressed. Once you've mastered the basics of making and producing sounds, you'll start to want to cue sounds or whole sections of sounds based on events such as these. A cue event is just an indication that something happened. For example, every time a live loop spins round, it sends a cue event out which is logged in the Cue Viewer. Also, external events such as MIDI messages from connected MIDI equipment and OSC messages from other programs or computers are also displayed in the Cue Viewer. It is also possible to directly generate cue events using the `cue` function. Anything that appears in the Cue Viewer can be used to trigger something happening. This is covered in more detail in Sections 10 to 12 of this tutorial.
