1.2 Explorando a Interface

# A Interface de Sonic Pi

Sonic Pi tem uma interface muito simples para codificar música. Vamos passar um tempinho explorando-a.

![Interface do Sonic Pi](../../../etc/doc/images/tutorial/GUI.png)


*A* - Controles de Reprodução
*B* - Controles de Edição
*C* - Ajuda e Informação
*D* - Editor de Código
*E* - Painel de Preferências
*F* - Visualizador de Log
*G* - Sistema de Ajuda
*H* - Visualizador de Escopo
*I* - Cue Viewer

## Controles

Esses botões rosas são os controles principais para inciar e finalizar sons. Há um botão *Run* para executar o código no editor, *Stop* para parar todo o código que está sendo executado, *Save* para salvar todo o código para um arquivo externo e *Record* para criar uma gravação (um arquivo WAV) do som que está tocando.

## B. Controles do Editor

These orange buttons allow you to manipulate the code editor. The *Size +* and *Size -* buttons allow you to make the text bigger and smaller.

## C. Ajuda e Informação

Esses botões azuis te dão acesso à informação, ajuda e preferências. O botão *Info* irá abrir a janela de informações na qual contém informação sobre o Sonic Pi - o time fonte, histórico, contribuidores e comunidade. O botão *Help* ativa o sistema de ajuda (*G*) e o botão *Prefs* ativa a janela de preferências na qual te permite controlar alguns parâmetros básicos do sistema.

## D. Editor de Código

Essa é a área em que você vai escrever seu código e compor/fazer música. É um simples editor de texto onde você pode escrever código,deleta-lo,recortar e colar, etc. Pense nele como uma versão muito básica do Word ou Google Docs. O editor vai colorir automaticamente as palavras baseado no seu significado no código. Isso parece estranho de primeira, mas logo você vai achar muito útil.Por exemplo, você saberá que algo é um número por que é azul.

## E. Painel de Preferências

O Sonic Pi suporta várias preferências ajustáveis que podem ser acessadas alternando o botão *prefs* no conjunto de botões Informações e Ajuda. Isto irá alternara a visibilidade do Painel de Preferências que inclui várias opções que podem ser alteradas. Exemplos: forçar o modo mono, inverter stereo, alternar a verbosidade do log de saída e também um slider de volume e um seletor de áudio no Raspberry Pi.

## F. Visualizador de logs

Quando você executa seu código, informações sobre o que o programa está fazendo serão exibidas no Visualizador do Log. Por padrão, você verá uma mensagem para cada som que você criou com o tempo exato em que o som foi disparado. Isto é muito útil para depurar seu código e entender o que seu código está fazendo.

## G. Sistema de Ajuda

Uma das partes mais importantes da interface do Sonic Pi é o sistema de ajuda que aparece na parte de baixo da janela. Ela pode ser ligada e desligada clicando no botão azul *Help*. O sistema de ajuda contem ajuda e informações sobre todos os aspectos do Sonic Pi, incluindo este tutorial, uma lista de sintetizadores, samples, exemplos, efeitos e uma lista com todas as funções que o Sonic Pi oferece para programar música.

## H. Visualizador de Onda

The visualizador de ondas permite que você veja o som que você está ouvindo. Você pode facilmente ver que a onda dente de serra parece com uma serra e que que o bip básico é uma curva senoidal. Você também pode ver a diferença entre sons intensos e calmos através dos tamanhos das linhas. Há 3 visualizações para trabalhar - a padrão mostra uma onda que combina os canais esquerdo e direito, há uma visualização stereo que mostra uma onda para cada canal. Finalmente há um visualizador de Curva de Lissajous que irá mostrar a relação de fase entre os canais esquerdo e direito e permite que você desenhe imagens bonitas com o som (https://pt.wikipedia.org/wiki/Curvas_de_Lissajous).

## I. Cue Viewer

All internal and external events (called cues in Sonic Pi) are automatically logged in the Cue Viewer. For example, if you have a MIDI controller connected and press one of its buttons, you'll see a new cue event in the Cue Viewer telling you the name of the controller and which button you pressed. Once you've mastered the basics of making and producing sounds, you'll start to want to cue sounds or whole sections of sounds based on events such as these. A cue event is just an indication that something happened. For example, every time a live loop spins round, it sends a cue event out which is logged in the Cue Viewer. Also, external events such as MIDI messages from connected MIDI equipment and OSC messages from other programs or computers are also displayed in the Cue Viewer. It is also possible to directly generate cue events using the `cue` function. Anything that appears in the Cue Viewer can be used to trigger something happening. This is covered in more detail in Sections 10 to 12 of this tutorial.
