2.3 Trocando Sintetizadores

# Trocando Sintetizadores

Até agora nós nos divertimos bastante fazendo bips. Entretanto você provavelmente está começando a ficar cansado do barulho deste bip básico. Isso é tudo que o Sonic Pi tem a oferecer? Certamente deve haver muito mais no 'live coding' do que só tocar bips? Sim, há e nesta seção exploraremos a excitante variedade de sons que o Sonic Pi tem a oferecer.

## Sintetizadores

O Sonic Pi tem uma variedade de instrumentos chamados synths, que é a *abreviação de sintetizadores*. Enquanto amostras representam sons pré-gravados, sintetizadores são capazes de gerar novos sons dependendo de como você os controla (o que exploraremos mais tarde neste tutorial). Os sintetizadores do Sonic Pi são muito poderosos e expressivos, e você se divertirá muito explorando e brincando com eles. Primeiro, vamos aprender como selecionar o sintetizador que vamos usar.

## Buzzy saws (dentes de serra ruidosas) e prophets (um sintetizador da Roland)

Um som divertido é a *onda dentes de serra* - vamos experimentá-lo:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
play 62
sleep 0.25
```

Vamos experimentar outro som - o *prophet*:

```
use_synth :prophet
play 38
sleep 0.25
play 50
sleep 0.25
play 62
sleep 0.25
```

Que tal combinarmos os dois sons. Primeiro um seguido do outro:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
use_synth :prophet
play 57
sleep 0.25
```

Now multiple sounds at the same time (by not sleeping between successive calls to `play`):

```
use_synth :tb303
play 38
sleep 0.25
use_synth :dsaw
play 50
sleep 0.25
use_synth :prophet
play 57
sleep 0.25
```

Note que o comando `use_synth`só afeta as próximas chamadas de `play`. Pense nele como um *grande interruptor* - novas chamadas de `play` irão tocar o sintetizador que tenha esteja selecionado no momento. Você pode trocar para um novo sintetizador com `use_synth`.


## Descobrindo os Sintetizadores

Para ver quais sintetizadores o Sonic Pi tem disponíveis para você, dê uma olhada na opção Sinths, bem a esquerda no menu vertical (acima de FX). Existem mais de 20 para se escolher. Aqui estão alguns dos meus favoritos:

`:prophet`
`:dsaw`
`:fm`
`:tb303`
`:pulse`

Agora brinque *trocando sintetizadores durante sua música*. Divirta-se combinando sintetizadores, para criar novos sons assim como usando diferentes sintetizadores em diferentes seções da sua música.
